﻿using System;
using System.Collections.Generic;
using Produmex.Foundation.Collections;
using System.Collections.ObjectModel;
using System.Linq;
using System.Data;
using System.Globalization;
using System.Reflection;
using System.Text;
using System.Transactions;
using Produmex.Foundation.Data.Sbo;
//using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.Utilities;
using Produmex.Foundation.Diagnostics;
using Produmex.Sbo.Logex.Data.Providers;
using Produmex.Sbo.Logex.Data.DataObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Convertors;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Data.Extensions.Interfacing.Definitions;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables;
using Produmex.Sbo.Logex.Data.DataObjects.Interfacing;
using Produmex.Foundation.Utilities;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.Tables;
using Produmex.Sbo.Logex.Data.Extensions.Interfacing;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Foundation.Convertors;
using Produmex.Foundation.Data.Sbo.DataObjects;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Data.Utilities;

namespace PmxCreatingSalesDeliveriesWHD
{
	class Program
	{
		private static string CONNECTION_STRING = "Server=BIT-LAP-036;CompanyDB=SBODemo_US_193;UseTrusted=False;DbUserName=sa;DbPassword=sapB1Admin;UserName=manager;Password=produmex;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2017;DBCultureInfo=en-US;LicenseServer=localhost:30000";

		private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);

		static void Main(string[] args)
		{
			try
			{
				Console.WriteLine(s_log.ToString());
				Console.WriteLine(CONNECTION_STRING);
				CreateSalesDeliveries();
			}
			catch (Exception ex)
			{
				s_log.Error("", ex);
				Console.WriteLine(ex);
				Console.ReadLine();
			}
		}

		private static class Definitions
		{
			public const string ViewName = "PMX_WHD_CREATING_SALES_DELIVERY_DATA";
			public const string ShipTo_Preficx = "ShipTo";
			public const string BillTo_Prefix = "BillTo";
		}

		private static void CreateSalesDeliveries()
		{


			//using (PmxDbConnectionSql conn = new PmxDbConnectionSql(CONNECTION_STRING))
			using (SboConnection conn = new SboConnection(CONNECTION_STRING))
			{
				DataSet ds = null;
				List<int> docEntries = new List<int>();
				PmxSalesDeliveryNoteProvider sdnProv = new PmxSalesDeliveryNoteProvider(conn);
				PmxItemAllConnectionsProvider itemProv = new PmxItemAllConnectionsProvider(conn);
				PmxDictionary<string, PmxSalesDeliveryNoteLine> groupedLines = null;
				PmxDictionary<int, PmxDictionary<string, int>> listOfSerialNumbersByLineNum = null;
				PmxDictionary<int, PmxDictionary<string, Collection<ReasonInfo>>> listOfReasonsByZoneTypesByLineNum = null;
				PmxDictionary<string, PmxItemInfo> itemInfosCache = new PmxDictionary<string, PmxItemInfo>();

				conn.Open();
				Console.Write("Connection is open");

				//get data alle data
				string query = String.Format("SELECT * FROM {0}", Definitions.ViewName);

				using (ISboRecordset rs = SboRecordsetHelper.RunQuery(s_log, query, conn))
				{
					Collection<string> itemCodes = new Collection<string>();

					if (!rs.EoF)
					{
						ds = SboRecordsetHelper.ConvertRecordsetToDataSet(s_log, rs);
						DataTable dt = ds.Tables[0];
						docEntries = dt.Rows.OfType<DataRow>().Select(r => r.Field<int>(PmxSalesDeliveryNoteTable.Columns.DocEntry.NAME)).Distinct().ToList();
					}

					while (!rs.EoF)
					{
						string itemCode = Convert.ToString(rs[PmxSalesOrderLineTable.Columns.ItemCode.NAME]);

						if (!itemCodes.Contains(itemCode))
						{
							itemCodes.Add(itemCode);
						}

						rs.MoveNext();
					}

					itemInfosCache = itemProv.GetCachedItemInfoInDictionary(itemCodes);
				}

				Console.Write("lines:" + docEntries.Count().ToString());
				//list of salesDocEntry

				foreach (int docEntry in docEntries)
				{
					DataRow[] rows = ds.Tables[0].Select(string.Format("{0} = '{1}' ", PmxSalesDeliveryNoteTable.Columns.DocEntry.NAME, docEntry));

					// add delivery
					using (PmxSalesDeliveryNote delNote = sdnProv.GetNewBO())
					{

						PmxDictionary<DocumentLineRef, double> listOfQuantityPerUom = new PmxDictionary<DocumentLineRef, double>();

						//header
						delNote.DocDueDate = Convert.ToDateTime(rows[0][PmxSalesOrderTable.Columns.DocDueDate.NAME]);					
						delNote.NumAtCard = Convert.ToString(rows[0][PmxSalesOrderTable.Columns.NumAtCard.NAME]);
						delNote.CardCode = Convert.ToString(rows[0][PmxSalesOrderTable.Columns.CardCode.NAME]);
						delNote.CardName = Convert.ToString(rows[0][PmxSalesOrderTable.Columns.CardName.NAME]);

						//BillTo
						delNote.ShipToCode = Convert.ToString(rows[0][PmxSalesOrderTable.Columns.ShipToCode.NAME]);
						delNote.PayToCode= Convert.ToString(rows[0]["PayToCode"]);
					
						foreach (DataRow row in rows)
						{						
							
							DocumentLineInfo delNoteLine = new DocumentLineInfo();

							delNoteLine.BaseType = (SboLinkDocumentType)SystemInt32Convertor.ObjectToInt(row[PmxSalesOrderLineTable.Columns.BaseType.NAME], (int)SboLinkDocumentType.NoLink, (int)SboLinkDocumentType.NoLink);

							if (delNoteLine.BaseType != SboLinkDocumentType.NoLink)
							{
								delNoteLine.BaseEntry = Convertor.ConvertToInt32Nullable(row[PmxSalesShippingLineTable.Columns.BaseEntry.NAME]);
								delNoteLine.BaseLine = Convertor.ConvertToInt32Nullable(row[PmxSalesShippingLineTable.Columns.BaseLine.NAME]);
							}

							delNoteLine.LineNum = Convert.ToInt32(row[PmxSalesOrderLineTable.Columns.BaseLine.NAME]);
							delNoteLine.ItemCode = Convert.ToString(row[PmxSalesOrderLineTable.Columns.ItemCode.NAME]);
							delNoteLine.ItemDescription = Convert.ToString(row[PmxSalesOrderLineTable.Columns.Description.NAME]);
							delNoteLine.WarehouseCode = Convert.ToString(row[PmxSalesOrderLineTable.Columns.WarehouseCode.NAME]);
							delNoteLine.StorageLocationCode = Convert.ToString(row[Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables.PmxDocumentLineColumns.StorageLocationCode.NAME]);							
							if (row[PmxSalesOrderLineTable.Columns.BestBeforeDate.NAME] == null || row[PmxSalesOrderLineTable.Columns.BestBeforeDate.NAME] == DBNull.Value || String.IsNullOrEmpty(row[PmxSalesOrderLineTable.Columns.BestBeforeDate.NAME].ToString()))
							{
								delNoteLine.BestBeforeDate = null;
							}
							else
							{
								delNoteLine.BestBeforeDate = DateTime.ParseExact(row[PmxSalesOrderLineTable.Columns.BestBeforeDate.NAME].ToString(), DateTimeHelper.DATE_FORMAT_DEFAULT, null); ;
							}
							delNoteLine.BatchNumber1 = Convert.ToString(row[PmxSalesOrderLineTable.Columns.PmxBatchNumber1.NAME]);
							delNoteLine.BatchNumber2 = Convert.ToString(row[PmxSalesOrderLineTable.Columns.PmxBatchNumber2.NAME]);
							delNoteLine.QualityStatusCode = Convert.ToString(row[Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables.PmxDocumentLineColumns.QualityStatusCode.NAME]);
							delNoteLine.LogisticUnitIdentKey = Convertor.ConvertToInt32Nullable(row[Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables.PmxDocumentLineColumns.LogisticUnitIdentificationKey.NAME]);
							delNoteLine.SSCC = Convert.ToString(row[Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables.PmxDocumentLineColumns.SSCC.NAME]);
							delNoteLine.Uom = Convert.ToString(row[PmxSalesOrderLineTable.Columns.UomCode.NAME]);
							delNoteLine.Quantity = Convert.ToDouble(row[PmxSalesOrderLineTable.Columns.Quantity.NAME]);					
							delNoteLine.QuantityPerUom = Convert.ToDouble(row[PmxSalesOrderLineTable.Columns.NumPerMsr.NAME]);						
							delNoteLine.UnitPrice = Convert.ToDouble(row[PmxSalesOrderLineTable.Columns.Price.NAME]);							
							
							//catch weight
							if (Convert.ToString(row[PmxItemTable.Columns.IsCatchWeightItem.NAME]) == "Y")
							{
								delNoteLine.QuantityUom2 =  Convert.ToDouble(row["WeightToDeliver"]);						
								delNoteLine.Uom2 = Convert.ToString(row[Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables.PmxDocumentLineColumns.Uom2.NAME]);
							}
							
							DocumentLineRef lineRef = new DocumentLineRef(((int)delNoteLine.BaseType).ToString(), delNoteLine.BaseEntry ?? -1, delNoteLine.BaseLine ?? -1);

							if (!listOfQuantityPerUom.ContainsKey(lineRef))
							{
								listOfQuantityPerUom.Add(lineRef, delNoteLine.QuantityPerUom);
							}
							
							PmxSalesDeliveryNoteLine line = Produmex.Sbo.Logex.Data.Utilities.DocumentInfoHelper.AddDocumentLineInfoToBO(delNoteLine, delNote, sdnProv, itemInfosCache, ref listOfSerialNumbersByLineNum, ref listOfReasonsByZoneTypesByLineNum, ref groupedLines);
							
							SetCatchWeightPrice(line, delNoteLine.UnitPrice / delNoteLine.QuantityPerUom, itemInfosCache[line.ItemCode]);						

						}

						try
						{

							using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
							{
								conn.EnlistTransaction(Transaction.Current);

								// Create the document in SAP
								int newDocEntry = Convert.ToInt32(sdnProv.AddBO(delNote, itemInfosCache, false));

								//Complete transaction
								scope.Complete();
							}
					
						}
						catch (Exception ex)
						{
							s_log.Error("", ex);
							Console.WriteLine(ex);
						}	
					}		
				}
			}
		}

		


		/// <summary>
		/// Sets the catch weight price.
		/// </summary>
		/// <param name="line">The line.</param>
		/// <param name="unitPrice">The unit price.</param>
		/// <param name="itemInfo">The item information.</param>
		protected static void SetCatchWeightPrice(PmxSalesDeliveryNoteLine line, double? unitPrice, PmxItemInfo itemInfo)
		{
			if (unitPrice.HasValue &&
				itemInfo.IsCatchWeightItem &&
				itemInfo.CatchWeightPriceCalculationForSales == PmxCatchWeightPriceCalculation.PriceByWeight)
			{
				if (!string.IsNullOrEmpty(line.PmxQuantityUOM2) &&
					line.BaseType == SboLinkDocumentType.SalesOrder)
				{
					//Get the weight
					string[] quantitiesUom2 = line.PmxQuantityUOM2.Split(SeparatorDefinition.SEPARATORVALUE);
					double weight = 0;

					foreach (string qty in quantitiesUom2)
					{
						weight += Convert.ToDouble(qty, System.Globalization.CultureInfo.InvariantCulture);
					}

					line.UnitPrice = unitPrice.Value / itemInfo.DefaultWeightForPiece * weight / line.Quantity;
				}
			}
		}

	}
}
